乘風破浪:LeetCode真題_032_Longest Valid Parentheses

乘風破浪:LeetCode真題_032_Longest Valid Parentheses

1、前言

   這也是很是有意思的一個題目,咱們以前已經遇到過兩個這種括號的題目了,基本上都要用到堆棧來解決,此次最簡單的方法固然也不例外。java

2、Longest Valid Parentheses

2.1 問題

2.2 分析與解決

    經過分析題意,這裏咱們有幾種方法:算法

       暴力算法:spa

public class Solution {
    public boolean isValid(String s) {
        Stack<Character> stack = new Stack<Character>();
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == '(') {
                stack.push('(');
            } else if (!stack.empty() && stack.peek() == '(') {
                stack.pop();
            } else {
                return false;
            }
        }
        return stack.empty();
    }
    public int longestValidParentheses(String s) {
        int maxlen = 0;
        for (int i = 0; i < s.length(); i++) {
            for (int j = i + 2; j <= s.length(); j+=2) {
                if (isValid(s.substring(i, j))) {
                    maxlen = Math.max(maxlen, j - i);
                }
            }
        }
        return maxlen;
    }
}

     可是對於比較長的字符串就會超時了,由於時間複雜度爲O(n~3):3d

 

      第二種方法:動態規劃blog

      咱們使用dp[i]表示前面的i個字符的最大有效括號長度,所以dp[0]=0,dp[1]=0,因而就能夠開始推出一個公式來計算了。字符串

public class Solution {
    public int longestValidParentheses(String s) {
        int maxans = 0;
        int dp[] = new int[s.length()];
        for (int i = 1; i < s.length(); i++) {
            if (s.charAt(i) == ')') {
                if (s.charAt(i - 1) == '(') {
                    dp[i] = (i >= 2 ? dp[i - 2] : 0) + 2;
                } else if (i - dp[i - 1] > 0 && s.charAt(i - dp[i - 1] - 1) == '(') {
                    dp[i] = dp[i - 1] + ((i - dp[i - 1]) >= 2 ? dp[i - dp[i - 1] - 2] : 0) + 2;
                }
                maxans = Math.max(maxans, dp[i]);
            }
        }
        return maxans;
    }
}

 

   方法三:經過咱們的方法,堆棧,很清晰很容易的解決了問題。string

public class Solution {

    public int longestValidParentheses(String s) {
        int maxans = 0;
        Stack<Integer> stack = new Stack<>();
        stack.push(-1);
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == '(') {
                stack.push(i);
            } else {
                stack.pop();
                if (stack.empty()) {
                    stack.push(i);
                } else {
                    maxans = Math.max(maxans, i - stack.peek());
                }
            }
        }
        return maxans;
    }
}

 

     固然還有其餘的方法,在此再也不贅述。io

3、總結

    在咱們遇到括號的時候必定要想到使用堆棧來解決,固然動態規劃是比較難的,咱們也要理解和使用。class

相關文章
相關標籤/搜索